diff --git a/arch/arm/cpu/armv7/omap5/prcm-regs.c b/arch/arm/cpu/armv7/omap5/prcm-regs.c
index 5a3d52c..56c497f 100644
--- a/arch/arm/cpu/armv7/omap5/prcm-regs.c
+++ b/arch/arm/cpu/armv7/omap5/prcm-regs.c
@@ -526,8 +526,6 @@ struct prcm_regs const omap5_es2_prcm = {
 	.cm1_abe_timer8_clkctrl = 0x4a004580,
 	.cm1_abe_wdt3_clkctrl = 0x4a004588,
 
-
-
 	/* cm2.ckgen */
 	.cm_clksel_mpu_m3_iss_root = 0x4a008100,
 	.cm_clksel_usb_60mhz = 0x4a008104,
diff --git a/board/LEOX/elpt860/README.LEOX b/board/LEOX/elpt860/README.LEOX
index fe3c0f1..aa41ff8 100644
--- a/board/LEOX/elpt860/README.LEOX
+++ b/board/LEOX/elpt860/README.LEOX
@@ -46,7 +46,6 @@ U-Boot, at the address of 0x03000000.
 
 =============================================================================
 
-
 ##################################################
 # Operation on the serial console (SMC1)
 ##############################
diff --git a/board/palmtreo680/README b/board/palmtreo680/README
index 46828eb..c8799c6 100644
--- a/board/palmtreo680/README
+++ b/board/palmtreo680/README
@@ -30,7 +30,6 @@ go wrong, but please tell me what happened exactly.  For that matter, I'd love
 to hear from you if you succeed.
 
 
-
 Details on the SPL
 ==================
 
@@ -51,7 +50,6 @@ IPL has already loaded to its correct SDRAM address, and then loads the
 remainder of u-boot and jumps to it.
 
 
-
 The docg4's "reliable mode"
 ===========================
 
@@ -79,7 +77,6 @@ module parameter), but not reading.  However, the u-boot docg4_spl driver does
 read in reliable mode, in the same fashion as the IPL.
 
 
-
 Details on the IPL and its data format
 ======================================
 
@@ -105,7 +102,6 @@ For the sake of simplicity and uniformity, the u-boot SPL mimics the operation
 of the IPL, and expects the image to be stored in the same format.
 
 
-
 Instructions on Programming u-boot to flash
 ===========================================
 
@@ -117,7 +113,6 @@ remainder of this document describes in detail how to program u-boot to the
 flash using Linux running on the Treo.
 
 
-
 Hardware Prerequisites
 ======================
 
@@ -136,7 +131,6 @@ A Linux desktop PC.
   to flash, you'll really want to use a Linux PC.
 
 
-
 Treo-side Software Prerequisites
 ================================
 
@@ -152,7 +146,6 @@ Linux bootloader for PalmOS:
   parameters passed to the kernel.
 
 
-
 Linux kernel:
 
   The kernel on the Treo 680 is still a little rough around the edges, and the
@@ -200,7 +193,6 @@ Linux kernel:
   and /dev/mtd2 for these partitions, respectively.  Ensure that your root file
   system at least has /dev/mtd1 if you are not running udev or mdev.
 
-
 Userspace Utilities:
 
   In addition to everything necessary to provide a useful userspace environment
@@ -221,19 +213,16 @@ Userspace Utilities:
   from the mtd-utils package.
 
 
-
 Desktop PC-side Software Prerequisites
 ======================================
 
 Terminal emulator application:
   minicom, kermit, etc.
 
-
 Linux kernel:
   Compiled with CONFIG_USB_SERIAL enabled.  Build this as a module.
 
 
-
 Recommended (Not directly related to u-boot)
 ============================================
 
@@ -275,7 +264,6 @@ configure the usb0 interface on the desktop.)  Use the nfs 'nolock' option when
 mounting to avoid the need to run a portmapper like rpcbind.
 
 
-
 Preliminaries
 =============
 
@@ -397,7 +385,6 @@ forget to copy the file to permanent storage, such as an mmc card.
 If all of the above went well, you can now program u-boot.
 
 
-
 Programming u-boot
 ==================
 
@@ -438,7 +425,6 @@ four blocks in /dev/mtd1; i.e., at offsets 0x00000, 0x40000, 0x80000, 0xc0000.
 Shutdown linux, remove and re-insert the battery, hold your breath...
 
 
-
 Enjoying u-boot
 ===============
 
@@ -478,7 +464,6 @@ support for reliable mode in u-boot's docg4 flash driver.  This should be
 corrected soon.
 
 
-
 Customizing
 ===========
 
@@ -511,7 +496,6 @@ in flash did not seem worth the cost of a 256k flash block.  But adding this
 should be straightforward.
 
 
-
 Restoring PalmOS
 ================
 
@@ -568,7 +552,6 @@ modprobe docg4 ignore_badblocks=1 || exit 1
 dd if=$1 bs=1 skip=$file_ofs count=540672 | nandwrite -o -n -s 0x80000 $2 - || exit 1
 modprobe -r docg4
 
-
 TODO
 ====
 
diff --git a/board/sandpoint/README b/board/sandpoint/README
index a2e0831..c9996a8 100644
--- a/board/sandpoint/README
+++ b/board/sandpoint/README
@@ -15,8 +15,6 @@ tkoeller@gmx.net.
 Thomas Koeller
 
 
-
-
 The port was tested on a Sandpoint 8240 X3 board, with U-Boot
 installed in the flash memory of the CPU card. Please use the
 following DIP switch settings:
diff --git a/board/siemens/rut/board.c b/board/siemens/rut/board.c
index f2b0476..5de8fc6 100644
--- a/board/siemens/rut/board.c
+++ b/board/siemens/rut/board.c
@@ -328,8 +328,6 @@ static int get_clk(struct dpll_regs *dpll_regs)
 	return f;
 };
 
-
-
 int clk_get(int clk)
 {
 	return get_clk(&dpll_lcd_regs);
@@ -426,7 +424,5 @@ static int board_video_init(void)
 
 	return 0;
 }
-
-
 #endif /* ifdef CONFIG_VIDEO */
 #include "../common/board.c"
diff --git a/doc/README.gpt b/doc/README.gpt
index 81dfe58..5c133f3 100644
--- a/doc/README.gpt
+++ b/doc/README.gpt
@@ -6,7 +6,6 @@
 #
 # SPDX-License-Identifier:	GPL-2.0+
 
-
 Glossary:
 ========
 - UUID -(Universally Unique Identifier)
@@ -22,7 +21,6 @@ Introduction:
 This document describes the GPT partition table format and usage of
 the gpt command in u-boot.
 
-
 UUID introduction:
 ====================
 
@@ -78,7 +76,6 @@ GPT brief explanation:
 	LBA -1         |Secondary GPT Header             |
 	----------------------------------------------------------
 
-
 For a legacy reasons, GPT's LBA 0 sector has a MBR structure. It is called
 "protective MBR".
 Its first partition entry ID has 0xEE value, and disk software, which is not
@@ -114,7 +111,6 @@ Offset  Size    Description
 TOTAL: 512 B
 
 
-
 IMPORTANT:
 
 GPT headers and partition entries are protected by CRC32 (the POSIX CRC32).
@@ -132,7 +128,6 @@ sizeof(partition_entry_size (usually 128)))
 Observe, how Secondary GPT is placed in the memory. It is NOT a mirror reflect
 of the Primary.
 
-
 	   Partition Entry Format:
 	   ----------------------
 	   Offset  Size    Description
@@ -150,7 +145,6 @@ of the Primary.
 	   Bit 62 - Hidden
 	   Bit 63 - Not mount
 
-
 Creating GPT partitions in U-Boot:
 ==============
 
@@ -171,7 +165,6 @@ To restore GUID partition table one needs to:
 2. From u-boot prompt type:
    gpt write mmc 0 $partitions
 
-
 Useful info:
 ============
 
diff --git a/doc/README.p1010rdb b/doc/README.p1010rdb
index dee63d7..6b2b5ff 100644
--- a/doc/README.p1010rdb
+++ b/doc/README.p1010rdb
@@ -185,7 +185,6 @@ Switch from NAND to NOR boot with Core/CCB/DDR (800/400/667 MHz):
 	=> reset
 
 
-
 Boot Linux from network using TFTP on P1010RDB
 ==============================================
 Place uImage, p1010rdb.dtb and rootfs files in the TFTP disk area.
diff --git a/doc/README.qemu-mips b/doc/README.qemu-mips
index 1fdfbab..a192752 100644
--- a/doc/README.qemu-mips
+++ b/doc/README.qemu-mips
@@ -15,7 +15,6 @@ recent qemu versions. When using emulated flash, launch with
 -pflash <filename> and erase mips_bios.bin.
 
 
-
 Notes for the Qemu MIPS port
 ----------------------------
 
diff --git a/doc/driver-model/UDM-block.txt b/doc/driver-model/UDM-block.txt
index b42ec69..ffbbdf3 100644
--- a/doc/driver-model/UDM-block.txt
+++ b/doc/driver-model/UDM-block.txt
@@ -218,7 +218,6 @@ II) Approach
   in near future.
 
 
-
 III) Analysis of in-tree drivers
 --------------------------------
 
diff --git a/drivers/usb/gadget/f_mass_storage.c b/drivers/usb/gadget/f_mass_storage.c
index b34068a..6ecdea3 100644
--- a/drivers/usb/gadget/f_mass_storage.c
+++ b/drivers/usb/gadget/f_mass_storage.c
@@ -9,7 +9,6 @@
  * SPDX-License-Identifier: GPL-2.0+	BSD-3-Clause
  */
 
-
 /*
  * The Mass Storage Function acts as a USB Mass Storage device,
  * appearing to the host as a disk drive or as a CD-ROM drive.  In
@@ -153,7 +152,6 @@
  * <http://www.usb.org/developers/devclass_docs/usbmass-ufi10.pdf>.
  */
 
-
 /*
  *				Driver Design
  *
@@ -264,7 +262,6 @@
 
 static const char fsg_string_interface[] = "Mass Storage";
 
-
 #define FSG_NO_INTR_EP 1
 #define FSG_NO_DEVICE_STRINGS    1
 #define FSG_NO_OTG               1
@@ -2629,8 +2626,6 @@ usb_copy_descriptors(struct usb_descriptor_header **src)
 	return ret;
 }
 
-
-
 static void fsg_unbind(struct usb_configuration *c, struct usb_function *f)
 {
 	struct fsg_dev		*fsg = fsg_from_func(f);
diff --git a/include/configs/T4240EMU.h b/include/configs/T4240EMU.h
index 9fa6b77..5e228f3 100644
--- a/include/configs/T4240EMU.h
+++ b/include/configs/T4240EMU.h
@@ -30,7 +30,6 @@
 #define CONFIG_DDR_CLK_FREQ	133333333
 #define CONFIG_FSL_TBCLK_EXTRA_DIV 100
 
-
 /*
  * DDR Setup
  */
@@ -76,7 +75,6 @@
 #define CONFIG_SYS_CS0_FTIM2		CONFIG_SYS_NOR_FTIM2
 #define CONFIG_SYS_CS0_FTIM3		CONFIG_SYS_NOR_FTIM3
 
-
 /* I2C */
 #define CONFIG_SYS_FSL_I2C_SPEED	4000000	/* faster speed for emulator */
 #define CONFIG_SYS_FSL_I2C2_SPEED	4000000
@@ -104,8 +102,6 @@
 #define CONFIG_SYS_QE_FMAN_FW_LENGTH	0x10000
 #define CONFIG_SYS_FDT_PAD		(0x3000 + CONFIG_SYS_QE_FMAN_FW_LENGTH)
 
-
-
 #define CONFIG_BOOTDELAY	0
 
 /*
diff --git a/tools/buildman/README b/tools/buildman/README
index b6b771c..6cecdb6 100644
--- a/tools/buildman/README
+++ b/tools/buildman/README
@@ -677,7 +677,6 @@ the build speed by building all commits for a board instead of the other
 way around.
 
 
-
 Simon Glass
 sjg@chromium.org
 Halloween 2012